/*
 Si consideri la Sintassi Astratta sotto, per il Lambda Calcolo:
    Lambda::= Var | Const | [$] Var Lambda | [@] Lambda Lambda
 dove usiamo $ per l'astrazione e @ per l'applicazione.
 Si chiede di fornire in C strutture, tipi, operazioni per la
 costruzione, l'accesso e la presentazione degli Abstract Syntax
 Tree dei termini del Linguaggio del Lambda Calcolo.
 In particolare, le operazioni richieste devono inludere:
 mkConst, mkVar, mkAbs, mkApp,
 isConst, isVar, isAbs, isApp
 getIde, getTem, getFun, getArg
 printAST.

*/
/*
Include il modulo "Last.c" e lo usa nella costruzione di AST di ter-
mini del Lambda Calcolo.
 
 ** AUTHOR: Marco Bellia
 ** LPL - Matematica
 ** Pisa 2019
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "Last.c"

int main(void){
    LastT x = mkVar("x");
    LastT y = mkVar("y");
    LastT xy = mkApp(x,y);
    LastT t = mkAbs("x",mkAbs("y",xy));
    printf("Il termine richiesto e' costruito dall'espressione:\n");
    printf("     mkAbs(\"x\",mkAbs(\"y\",mkApp(mkVar(\"x\"),mkVar(\"y\"))))\n");
    printf("e printAST ne fornisce la presentazione seguente:\n     ");
    printAST(t);
    printf("\n");
    //altri termini, altri test di uso delle operazione, qui sotto:
}

/*
 host-131-114-220-116:LambdaASTin marcob$ cc main.c -o ZCode/main.exe
 host-131-114-220-116:LambdaASTinCExt marcob$ ./ZCode/main.exe
 Il termine richiesto e' costruito dall'espressione:
        mkAbs("x",mkAbs("y",mkApp(mkVar("x"),mkVar("y"))))
 e printAST ne fornisce la presentazione seguente:
        [$-(x,[$-(y,[@ -([x],[y])])])]
 host-131-114-220-116:LambdaASTin marcob$
 */
