/*
 Si consideri la Sintassi Astratta sotto, per il Lambda Calcolo:
    Lambda::= Var | Const | [$] Var Lambda | [@] Lambda Lambda
 dove usiamo $ per l'astrazione e @ per l'applicazione.
 Si chiede di fornire in C strutture, tipi, operazioni per la
 costruzione, l'accesso e la presentazione degli Abstract Syntax
 Tree dei termini del Linguaggio del Lambda Calcolo.
 In particolare, le operazioni richieste devono inludere:
 mkConst, mkVar, mkAbs, mkApp,
 isConst, isVar, isAbs, isApp
 getIde, getTem, getFun, getArg
 printAST,

*/
/*
Include il modulo "Last.c" e lo usa nella costruzione di AST di ter-
mini del Lambda Calcolo.
 
 ** AUTHOR: Marco Bellia
 ** LPL - Matematica
 ** Pisa 2019
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "Last.c"

int main(void){
    LastT x = mkVar("x");
    LastT y = mkVar("y");
    LastT z = mkVar("z");
    LastT xy = mkApp(x,y);
    LastT t1 = mkAbs("x",xy);
    LastT t2 = mkApp(t1,z);
    printAST(t2);
    printf("\n");
}

/*
 MarcoBelliasAir:LambdaASTinC marcob$ ./a.out
 [@ -([$-(x,[@ -([x],[y])])],[z])]
 MarcoBelliasAir:LambdaASTinC marcob$
 */
